Debian Bug report logs - #441857
libc6: resolver is broken for local IPv6 networking due to patch from #435646

version graph

Package: libc6; Maintainer for libc6 is GNU Libc Maintainers <debian-glibc@lists.debian.org>; Source for libc6 is src:eglibc.

Reported by: Roger Leigh <rleigh@debian.org>

Date: Tue, 11 Sep 2007 13:39:02 UTC

Severity: important

Tags: ipv6

Found in version glibc/2.6.1-2

Fixed in version glibc/2.6.1-4

Done: Aurelien Jarno <aurel32@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Andrew McMillan <debian@mcmillan.net.nz>, Andrew Ruthven <andrew.ruthven@catalyst.net.nz>, Aurelien Jarno <aurel32@debian.org>, Tollef Fog Heen <tfheen@debian.org>, GNU Libc Maintainers <debian-glibc@lists.debian.org>:
Bug#441857; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@debian.org>:
New Bug report received and forwarded. Copy sent to Andrew McMillan <debian@mcmillan.net.nz>, Andrew Ruthven <andrew.ruthven@catalyst.net.nz>, Aurelien Jarno <aurel32@debian.org>, Tollef Fog Heen <tfheen@debian.org>, GNU Libc Maintainers <debian-glibc@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libc6: resolver is broken for local IPv6 networking due to patch from #435646
Date: Tue, 11 Sep 2007 14:37:29 +0100
[Message part 1 (text/plain, inline)]
Package: libc6
Version: 2.6.1-2
Severity: important

As the title implies, IPv6 networking is now broken when the system
does not have a globally scoped IPv6 address.  As I discovered a few
weeks ago, this has a nasty side effect of breaking all local IPv6
services, because they are not longer considered.

I have written a test program (addrtest, attached) to demonstrate.
Compile with

    c99 -o addrtest addrtest.c

and run with no arguments.  To demonstrate the problem with a
Leafnode NNTP server running via openbsd-inetd on the localhost:

% grep nntp /etc/inetd.conf
nntp  stream  tcp6  nowait  news  /usr/sbin/tcpd /usr/sbin/leafnode

% netstat --tcp -l | grep nntp
tcp6       0      0 *:nntp                  *:*                    LISTEN

% /sbin/ifconfig
eth0      Link encap:Ethernet  HWaddr 00:11:24:75:6D:56
          inet addr:192.168.156.21  Bcast:192.168.156.255  Mask:255.255.255.0
          inet6 addr: fe80::211:24ff:fe75:6d56/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:244661 errors:0 dropped:0 overruns:0 frame:0
          TX packets:170326 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:268682462 (256.2 MiB)  TX bytes:16191957 (15.4 MiB)
          Interrupt:41 Base address:0xa400

lo        Link encap:Local Loopback
          inet addr:127.0.0.1  Mask:255.0.0.0
          inet6 addr: ::1/128 Scope:Host
          UP LOOPBACK RUNNING  MTU:16436  Metric:1
          RX packets:1200579 errors:0 dropped:0 overruns:0 frame:0
          TX packets:1200579 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:362353281 (345.5 MiB)  TX bytes:362353281 (345.5 MiB)

% ./addrtest

Addrinfo for 0x100120c0
Flags:          32
Family:         2
Socket Type:    1
Protocol:       6 (tcp)
Canonical name: (null)
Socket Address (len=16):
  Port:         119
  IPv4 Address: 127.0.0.1

Addrinfo for 0x100120f8
Flags:          32
Family:         2
Socket Type:    2
Protocol:       17 (udp)
Canonical name: (null)
Socket Address (len=16):
  Port:         119
  IPv4 Address: 127.0.0.1

% sudo /etc/init.d/aiccu start
Starting SixXS Automatic IPv6 Connectivity Client Utility (aiccu)...Tunnel Information for T11225:
POP Id      : iedub01
IPv6 Local  : 2001:770:100:ca::2/64
IPv6 Remote : 2001:770:100:ca::1/64
Tunnel Type : 6in4-heartbeat
Adminstate  : enabled
Userstate   : enabled
.

% /sbin/ifconfig
eth0      Link encap:Ethernet  HWaddr 00:11:24:75:6D:56
          inet addr:192.168.156.21  Bcast:192.168.156.255  Mask:255.255.255.0
          inet6 addr: fe80::211:24ff:fe75:6d56/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:244762 errors:0 dropped:0 overruns:0 frame:0
          TX packets:170366 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:268691686 (256.2 MiB)  TX bytes:16195883 (15.4 MiB)
          Interrupt:41 Base address:0xa400

lo        Link encap:Local Loopback
          inet addr:127.0.0.1  Mask:255.0.0.0
          inet6 addr: ::1/128 Scope:Host
          UP LOOPBACK RUNNING  MTU:16436  Metric:1
          RX packets:1200584 errors:0 dropped:0 overruns:0 frame:0
          TX packets:1200584 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:362354897 (345.5 MiB)  TX bytes:362354897 (345.5 MiB)

sixxs     Link encap:IPv6-in-IPv4
          inet6 addr: 2001:770:100:ca::2/64 Scope:Global
          inet6 addr: fe80::c0a8:9c15/64 Scope:Link
          UP POINTOPOINT RUNNING NOARP  MTU:1280  Metric:1
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0
          TX packets:0 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:0 (0.0 b)  TX bytes:0 (0.0 b)

% ./addrtest

Addrinfo for 0x10012140
Flags:          32
Family:         2
Socket Type:    1
Protocol:       6 (tcp)
Canonical name: (null)
Socket Address (len=16):
  Port:         119
  IPv4 Address: 127.0.0.1

Addrinfo for 0x100128b0
Flags:          32
Family:         2
Socket Type:    2
Protocol:       17 (udp)
Canonical name: (null)
Socket Address (len=16):
  Port:         119
  IPv4 Address: 127.0.0.1

Addrinfo for 0x100128e8
Flags:          32
Family:         2
Socket Type:    3
Protocol:       0 (ip)
Canonical name: (null)
Socket Address (len=16):
  Port:         119
  IPv4 Address: 127.0.0.1

Addrinfo for 0x100120c0
Flags:          32
Family:         10
Socket Type:    1
Protocol:       6 (tcp)
Canonical name: (null)
Socket Address (len=28):
  Port:         119
  IPv6 Address: ::1

Addrinfo for 0x10012100
Flags:          32
Family:         10
Socket Type:    2
Protocol:       17 (udp)
Canonical name: (null)
Socket Address (len=28):
  Port:         119
  IPv6 Address: ::1


As the above demonstrates, the service is not actually accessible
when the SiXXS link is down, due to only (invalid) IPv4 results
being returned.  Even if they were valid, TCP wrappers would not
allow the connection.  This means clients like slrn and Gnus can
not connect.  It is reasonable to expect a service running on
the localhost to be accessible whether or not other unrelated
interfaces are up or down.


Regards,
Roger

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (990, 'unstable')
Architecture: powerpc (ppc)

Kernel: Linux 2.6.22-2-powerpc
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages libc6 depends on:
ii  libgcc1                       1:4.2.1-5  GCC support library

libc6 recommends no packages.

-- no debconf information
[addrtest.c (text/x-c, attachment)]

Tags added: ipv6 Request was from Roger Leigh <rleigh@whinlatter.ukfsn.org> to control@bugs.debian.org. (Tue, 11 Sep 2007 14:00:08 GMT) Full text and rfc822 format available.

Tags added: pending Request was from Aurelien Jarno <aurel32@alioth.debian.org> to control@bugs.debian.org. (Tue, 11 Sep 2007 14:21:05 GMT) Full text and rfc822 format available.

Reply sent to Aurelien Jarno <aurel32@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Roger Leigh <rleigh@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #14 received at 441857-close@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurel32@debian.org>
To: 441857-close@bugs.debian.org
Subject: Bug#441857: fixed in glibc 2.6.1-4
Date: Fri, 14 Sep 2007 00:32:05 +0000
Source: glibc
Source-Version: 2.6.1-4

We believe that the bug you reported is fixed in the latest version of
glibc, which is due to be installed in the Debian FTP archive:

glibc-doc_2.6.1-4_all.deb
  to pool/main/g/glibc/glibc-doc_2.6.1-4_all.deb
glibc_2.6.1-4.diff.gz
  to pool/main/g/glibc/glibc_2.6.1-4.diff.gz
glibc_2.6.1-4.dsc
  to pool/main/g/glibc/glibc_2.6.1-4.dsc
libc6-dbg_2.6.1-4_amd64.deb
  to pool/main/g/glibc/libc6-dbg_2.6.1-4_amd64.deb
libc6-dev-i386_2.6.1-4_amd64.deb
  to pool/main/g/glibc/libc6-dev-i386_2.6.1-4_amd64.deb
libc6-dev_2.6.1-4_amd64.deb
  to pool/main/g/glibc/libc6-dev_2.6.1-4_amd64.deb
libc6-i386_2.6.1-4_amd64.deb
  to pool/main/g/glibc/libc6-i386_2.6.1-4_amd64.deb
libc6-pic_2.6.1-4_amd64.deb
  to pool/main/g/glibc/libc6-pic_2.6.1-4_amd64.deb
libc6-prof_2.6.1-4_amd64.deb
  to pool/main/g/glibc/libc6-prof_2.6.1-4_amd64.deb
libc6-udeb_2.6.1-4_amd64.udeb
  to pool/main/g/glibc/libc6-udeb_2.6.1-4_amd64.udeb
libc6_2.6.1-4_amd64.deb
  to pool/main/g/glibc/libc6_2.6.1-4_amd64.deb
libnss-dns-udeb_2.6.1-4_amd64.udeb
  to pool/main/g/glibc/libnss-dns-udeb_2.6.1-4_amd64.udeb
libnss-files-udeb_2.6.1-4_amd64.udeb
  to pool/main/g/glibc/libnss-files-udeb_2.6.1-4_amd64.udeb
locales-all_2.6.1-4_amd64.deb
  to pool/main/g/glibc/locales-all_2.6.1-4_amd64.deb
locales_2.6.1-4_all.deb
  to pool/main/g/glibc/locales_2.6.1-4_all.deb
nscd_2.6.1-4_amd64.deb
  to pool/main/g/glibc/nscd_2.6.1-4_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 441857@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Aurelien Jarno <aurel32@debian.org> (supplier of updated glibc package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Thu, 13 Sep 2007 17:05:17 +0200
Source: glibc
Binary: libc0.1-prof libc6-dev-amd64 locales-all libc6-i686 libc6-dev-ppc64 libc0.3-pic glibc-doc libc0.3 libc6-dev-mipsn32 libc0.1-i686 libc0.1-i386 libc6-mips64 libc6.1-dev libc6-s390x libnss-files-udeb libc0.1-dev-i386 libc6-dev-sparc64 libc6-i386 libc0.3-dev libc6-udeb libc6-dbg libc6.1-pic libc6-dev libc0.3-prof libc0.1-udeb libc6-dev-i386 libc6.1-prof libc6-mipsn32 libc0.1-dev locales libc6-pic libc0.3-udeb libc6-dev-powerpc libc0.1-pic libc6-ppc64 libc0.3-dbg libc0.1-dbg libc6-amd64 libc0.1 libc6-prof libc6-xen libc6-dev-mips64 libc6-powerpc libc6 libc6-sparcv9b libc6.1-udeb libc6.1-dbg nscd libc6-sparc64 libnss-dns-udeb libc6.1 libc6-dev-s390x
Architecture: source amd64 all
Version: 2.6.1-4
Distribution: unstable
Urgency: low
Maintainer: Aurelien Jarno <aurel32@debian.org>
Changed-By: Aurelien Jarno <aurel32@debian.org>
Description: 
 glibc-doc  - GNU C Library: Documentation
 libc6      - GNU C Library: Shared libraries
 libc6-dbg  - GNU C Library: Libraries with debugging symbols
 libc6-dev  - GNU C Library: Development Libraries and Header Files
 libc6-dev-i386 - GNU C Library: 32bit development libraries for AMD64
 libc6-i386 - GNU C Library: 32bit shared libraries for AMD64
 libc6-pic  - GNU C Library: PIC archive library
 libc6-prof - GNU C Library: Profiling Libraries
 libc6-udeb - GNU C Library: Shared libraries - udeb (udeb)
 libnss-dns-udeb - GNU C Library: NSS helper for DNS - udeb (udeb)
 libnss-files-udeb - GNU C Library: NSS helper for files - udeb (udeb)
 locales    - GNU C Library: National Language (locale) data [support]
 locales-all - GNU C Library: Precompiled locale data
 nscd       - GNU C Library: Name Service Cache Daemon
Closes: 441026 441355 441824 441857 441959 442101 442104
Changes: 
 glibc (2.6.1-4) unstable; urgency=low
 .
   * Disable any/local-ipv6-lookup.diff as it is causing breakages.
     Closes: bug#441857.
   * any/local-sysmacros.diff: use __inline instead of inline for
     compatibility with ANSI.  Closes: #441959.
   * patches/localedata/tailor-iso14651_t1.diff: correctly fix fi_FI
     locale.  Closes: bug#441026.
   * debian/rules.d/debhelper.mk: fix regex.  Closes: #441824.
   * Update French debconf translation, by Christian Perrier.  Closes:
     #442101.
   * any/submitted-regex-collate.diff: fix regex engine for multibyte
     characters and C collation.  Closes: #441355.
   * debian/local/manpages/locale-gen.8: fix manpage.  Closes: #442104.
Files: 
 5549398b201b86e0381fb24b909d06ac 2059 libs required glibc_2.6.1-4.dsc
 28cbad9100a811c20e76b7ddd2024727 678976 libs required glibc_2.6.1-4.diff.gz
 f0713d389e90cc02731a12e64ecc2a14 1596666 doc optional glibc-doc_2.6.1-4_all.deb
 87fdd626b98ab4bccf45db866fe48de8 4399204 libs standard locales_2.6.1-4_all.deb
 e21d60c5b08354f2fc5a0fab375d5405 4916228 libs required libc6_2.6.1-4_amd64.deb
 2a297149a9b2dfc13fbf48b2b9ecfcf6 2494886 libdevel optional libc6-dev_2.6.1-4_amd64.deb
 902e283906bbe57347c94b8587d32d34 1931006 libdevel extra libc6-prof_2.6.1-4_amd64.deb
 644e895923b7bd59f8bb558a9445ee7b 1466576 libdevel optional libc6-pic_2.6.1-4_amd64.deb
 51423688ebcfb4352d3c3a264fae9786 2468524 libs extra locales-all_2.6.1-4_amd64.deb
 bf6683f7177fdedb8141aff1f60aa3e6 3706012 libs optional libc6-i386_2.6.1-4_amd64.deb
 ba3ed101070afa50a198136c428136ba 1403854 libdevel optional libc6-dev-i386_2.6.1-4_amd64.deb
 b4f6b83a4cff0b69ade1377eb16ae34c 165188 admin optional nscd_2.6.1-4_amd64.deb
 5913e24cbb8176e819614f43fb00e0a0 5229400 libdevel extra libc6-dbg_2.6.1-4_amd64.deb
 20f3216c6f3fb474da7d3bf6ff7f0833 1112134 debian-installer extra libc6-udeb_2.6.1-4_amd64.udeb
 f8e3ef9ed2b065c48d1a06a53b306fbc 9742 debian-installer extra libnss-dns-udeb_2.6.1-4_amd64.udeb
 922564515accfdf47d327318a9563aed 17874 debian-installer extra libnss-files-udeb_2.6.1-4_amd64.udeb
Package-Type: udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFG6dHpw3ao2vG823MRAvg3AJ4wmiixjKDCjfpYbp5wRurqXjWyRgCfbIrH
sN83QxRtTG70nKiceVDS2xg=
=BqvK
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 14 Oct 2007 07:32:20 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 23:35:36 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.